# aptos_api_dart.model.PendingTransaction

## Load the model package
```dart
import 'package:aptos_api_dart/api.dart';
```

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**type** | **String** |  | 
**hash** | **String** | All bytes data are represented as hex-encoded string prefixed with `0x` and fulfilled with two hex digits per byte.  Different with `Address` type, hex-encoded bytes should not trim any zeros.  | 
**sender** | **String** | Hex-encoded 16 bytes Aptos account address.  Prefixed with `0x` and leading zeros are trimmed.  See [doc](https://diem.github.io/move/address.html) for more details.  | 
**sequenceNumber** | **String** | Unsigned int64 type value | 
**maxGasAmount** | **String** | Unsigned int64 type value | 
**gasUnitPrice** | **String** | Unsigned int64 type value | 
**gasCurrencyCode** | **String** |  | [optional] 
**expirationTimestampSecs** | **String** | Timestamp in seconds, e.g. transaction expiration timestamp.  | 
**payload** | [**TransactionPayload**](TransactionPayload.md) |  | 
**signature** | [**TransactionSignature**](TransactionSignature.md) |  | 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


